@echo off
if exist debug echo on
rem -----------------------------------------------------------------------------
rem                       GRTOOL - A Link To Grid Interface
rem -----------------------------------------------------------------------------
rem FILE    : grannot.bat Version 2.5 
rem DATE    : 16-12-93
rem AUTHOR  : Lukas Spiess
rem USAGE   : grannot [-d data] parameter-file input-file [annotation-file] 
rem
rem REMARKS : Be sure that either
rem           - GRANNOTA.EXE is in a directory of the path or
rem           - the environment variable GRTOOL is set to the directory
rem             containing GRANNOTA.[AWK,EXE] (E.g. set GRTOOL=c:\grtool)
rem 
rem CHANGE  :
rem 04-01-94: One batchfile for both awk and exe versions
rem 05-01-94: Autodetection of GRANNOTA.AWK to set the variable GRTOOL,
rem           searching in the current and the path directories.
rem           Problem: This doesn't work properly with long pathes.
rem 28-01-94: - Environment variable GRTOOL changed to GRTOOL
rem           - Name GRANNOT.AWK changed to GRANNOTA.AWK
rem           - Batch control structure modified, more error messages 
rem 31-01-94: - Commandline option -d data added for overwriting the
rem             data selection in the parameter-file (Keyword DN column).
rem             The new usage is:
rem             grannot [-d data] parameter-file input-file [annotation-file] 
rem 10-02-94: - The same awk file can used on DOS and UNIX systmes without any
rem             changes. The temporary file grtool.tmp, which has to be
rem             created by the DOS batch file or by the UNIX shell script
rem             allows to specify the message output device by the keyword
rem             OUTPUT device and the sort program to be used is referenced by
rem             the keyword GRSORT sort-program. Under this is usually 
rem             GRSORT gsort and OUTPUT con, under UNIX GRSORT sort and
rem             OUTPUT grtool.log or /dev/tty.
rem *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 

set output=con
set ifile=con
set datsel=

if x%1 == x-d set datsel=%2
if x%1 == x-d goto withOpt

if x%1 == x goto Error
if not x%1 == x set pfile=%1
if not exist %1 goto NoParFile
if x%2 == x goto Error
if not x%2 == x set ifile=%2
if not exist %2 goto NoInpFile
if not x%3 == x set output=%3
goto detect

:withOpt
if x%3 == x goto Error
if not x%3 == x set pfile=%3
if not exist %3 goto NoParFile
if x%4 == x goto Error
if not x%4 == x set ifile=%4
if not exist %4 goto NoInpFile
if not x%5 == x set output=%5

:detect
if not %GRTOOL%x == x goto NoAutoDetection 
echo Autodetection of GRANNOTA.EXE and GRANNOTA.AWK ...
set GRTOOL=.
for %%f in (%path% .) do if exist %%f\grannota.awk set GRTOOL=%%f
if not %GRTOOL%x == x set Call=gawk -f %GRTOOL%\grannota.awk 
for %%f in (%path% .) do if exist %%f\grannota.exe set Call=grannota.exe
if %Call%x == x goto NoProgram
goto Run
:NoAutoDetection
echo Variable GRTOOL is currently : %GRTOOL%
if exist %GRTOOL%\grannota.awk set Call=gawk -f %GRTOOL%\grannota.awk 
if exist %GRTOOL%\grannota.exe set Call=%GRTOOL%\grannota.exe 
if %Call%x == x goto NoProgram
:Run
echo OUTPUT con > grtool.tmp
echo Running module: %Call% ...
%Call% dn=%datsel% pf=%pfile% %ifile% > %output%
if exist grtool.tmp del grtool.tmp
goto End
:Error
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
echo Usage: GRANNOT [-d data] parameter-file input-file [annotation-file] 
echo        E.g. grannot parfile grout annota
echo        E.g. grannot -d @NO2 parfile grout annota
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
goto Exit
:NoProgram
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
echo ERROR: Neither GRANNOTA.EXE nor GRANNOTA.AWK are executable ! 
echo        Put the program to a path directory or set GRTOOL correctly !
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
goto Exit
:NoParFile
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
echo ERROR: Parameter-file %pfile% not found ! 
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
goto Exit
:NoInpFile
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
echo ERROR: Input-file %ifile% not found ! 
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
goto Exit
:End
if %GRTOOL%x == .x set GRTOOL=
set Call=
set datsel=
set pfile=
set ifile=
:Exit
