@echo off
if exist debug echo on
rem -----------------------------------------------------------------------------
rem                       GRTOOL - A Link To Grid Interface
rem -----------------------------------------------------------------------------
rem FILE    : grlink.bat Version 2.5 
rem DATE    : 16-12-93
rem AUTHOR  : Lukas Spiess
rem USAGE   : grlink input-file grid-distance [output-file]
rem 
rem REMARKS : Be sure that either 
rem           - GRLINKA.EXE is in a directory of the current path or
rem           - the environment variable GRTOOL is set to the directory
rem             containing GRLINKA.[AWK,EXE] (E.g. set GRTOOL=c:\grtool)
rem           furthermore
rem           - the input-file has been created with GRMACRO 
rem           - the GNU sort.EXE is named gsort.exe
rem 
rem CHANGES :
rem 04-01-94: - One batchfile for both awk and exe versions
rem 05-01-94: - Autodetection of GRLINKA.AWK to set the variable GRTOOL,
rem             searching in the current and the path directories.
rem             Problem: This doesn't work properly with long pathes.
rem 28-01-94: - Environment variable GRID changed to GRTOOL
rem           - Name GRLINK.AWK changed to GRLINKA.AWK
rem           - GNU sort.exe call changed to gsort.exe in grlinka.awk
rem           - Batch control structure modified, more error messages 
rem 10-02-94: - The same awk file can used on DOS and UNIX systmes without any
rem             changes. The temporary file grtool.tmp, which has to be
rem             created by the DOS batch file or by the UNIX shell script
rem             allows to specify the message output device by the keyword
rem             OUTPUT device and the sort program to be used is referenced by
rem             the keyword GRSORT sort-program. Under this is usually 
rem             GRSORT gsort and OUTPUT con, under UNIX GRSORT sort and
rem             OUTPUT grtool.log or /dev/tty.
rem *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 

set output=con
if x%1 == x goto Error
if x%2 == x goto Error
if not exist %1 goto NoFile
if not x%3 == x set output=%3
echo Input-file   = %1
echo Output-file  = %output%
echo Grid-distance= %2
if not %GRTOOL%x == x goto NoAutoDetection 
echo Autodetection of GRLINKA.EXE and GRLINKA.AWK ...
set GRTOOL=.
for %%f in (%path% .) do if exist %%f\grlinka.awk set GRTOOL=%%f
if not %GRTOOL%x == x set Call=gawk -f %GRTOOL%\grlinka.awk 
for %%f in (%path% .) do if exist %%f\grlinka.exe set Call=grlinka.exe
if %Call%x == x goto NoProgram
goto Run
:NoAutoDetection
echo Variable GRTOOL is currently : %GRTOOL%
if exist %GRTOOL%\grlinka.awk set Call=gawk -f %GRTOOL%\grlinka.awk 
if exist %GRTOOL%\grlinka.exe set Call=%GRTOOL%\grlinka.exe 
if %Call%x == x goto NoProgram
:Run
echo GRLINK1 > grtool.tmp
echo The running module is       : %Call% ...
echo .... intersecting links with grid cells
%Call% GD=%2 %1 > %output%
echo .... sorting temporary link/grid file
gsort gridlink.tmp >gridsort.tmp
echo .... generating grid data file
echo GRLINK2 > grtool.tmp
%Call% GD=%2 >> %output%
goto End
:Error
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
echo Usage: GRLINK input-file grid-distance(s) [output-file]
echo        E.g. grlink batchout 1 grout
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
goto Exit
:NoFile
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
echo ERROR: Input-file %1 does not exist ! 
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
goto Exit
:NoProgram
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
echo ERROR: Neither GRLINKA.EXE nor GRLINKA.AWK are executable ! 
echo        Put the program to a path directory or set GRTOOL correctly !
echo *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
goto Exit
:End
if exist debug goto Exit
if exist gridlink.tmp del gridlink.tmp
if exist gridsort.tmp del gridsort.tmp
if exist grtool.tmp del grtool.tmp
:Exit
if %GRTOOL%x == .x set GRTOOL=
set GRLINK=
set Call=
